cimport numpy as np
import numpy as np

ctypedef np.int_t num_t
ctypedef Py_ssize_t index_t


cdef class Summer:

    cdef np.ndarray a
    cdef num_t* a_p
    cdef index_t a_nd, n

    def __init__(self,a,n):
        self.a = a
        #ugly hack to get direct data buffer
        self.a_p = <num_t*>self.a.data
        self.a_nd = self.a.shape[0]
        self.n = n
    
    cpdef int sum(self):
        cdef num_t s = 0
        cdef index_t i, j
        for i in range(self.n):
            for j in range(self.n):
                s += self.a_p[i*self.a_nd+j]
        return s
